;; GAMLP-OMPD Formulario Digital de Registro Catastral
;; Nelson Huanquiri (c) 2012 La Paz, Bolivia

(defun InstalarFDRC ( carpeta archivo nombre / customFile strfiles tmp menux
		     count itemx acapp n)
  (vl-load-com)

  (setq	customFile (cond
		     ((< (atoi (getvar 'AcadVer)) 18)
		      (strcat archivo ".cui")
		     )
		     (t (strcat archivo ".cuix"))
		   )
	strfiles   (vla-get-files
		     (vla-get-preferences (vlax-get-acad-object))
		   )
  )

  (if (not (vl-string-search
	     (strcase carpeta)
	     (strcase (vla-get-supportpath strfiles))
	   )
      )
    (progn
      (setq tmp (strcat (vla-get-supportpath strfiles) ";" carpeta))
      (vla-put-supportpath strfiles tmp)
    )
  )
  
  ;; cargando el cui
  ;; (if (menugroup nombre) (command "_.cuiunload" nombre))

  (if (not (menugroup nombre))
    (command "_.cuiload" (strcat carpeta "\\" customFile))
  )


  (setq menux (vla-get-menubar(vlax-get-acad-object)))
  (setq count (vla-get-count menux)
	itemx nil
  )
  (while (>= (setq count (1- count)) 0)
    (setq names (vla-get-name (vla-item menux count)))
    (if (wcmatch names "*FDRC") (setq itemx names))
  )

  (if (not itemx)
    (progn
      (vlax-for	n
		(vla-get-MenuGroups (setq acapp (vlax-get-acad-object)))
	(if (eq (vla-get-name n) nombre)
	  (vla-InsertinMenuBar
	    (vla-item (vla-get-menus n) 0)
	    (1- (vla-get-Count (vla-get-MenuBar acapp)))
	  )
	)
      )
    )
  )

  (princ)
)

(defun SetFolderFDRC (/ *error*)
  (vl-load-com)

  (defun *error* (msg)
    (if	oShell
      (setq oShell (vlax-release-object oShell))
    )
    (cond ((not msg))			; Normal exit
	  ((member msg '("Function cancelled" "quit / exit abort")))
					; <esc> or (quit)
	  ((princ (strcat "\n** Error: " msg " ** ")))
    )					; Fatal error, display it
    (princ)
  )

  ((lambda (acApp / oShell oFolder path extesion archivocui)
     (if
       (and
	 (setq oShell (vlax-get-or-create-object "Shell.Application"))
	 (setq oFolder (vlax-invoke oShell 'BrowseForFolder (vla-get-hwnd acApp)
		  "Seleccione la carpeta de instalacin de FDRC" 0   17))
       )
       (progn
	 (setq path (vlax-get-property (vlax-get-property oFolder 'Self) 'Path))
	 (setq extension (cond
			   ((< (atoi (getvar 'AcadVer)) 18) ".cui")
			   (t ".cuix")
			 )
	 )
	 (if
	   (setq archivocui (findfile (strcat path "\\fdrc_catastro" extension)))
	   (InstalarFDRC path "fdrc_catastro" "FDRC_CATASTRO")
	   (*error* (strcat "No se encontro el archivo fdrc_catastro" extension))
	 )
       )
       (cond
         (oShell (*error* nil))
         ((*error* "No se pudo crear Shell.Application Object"))
       )
     )
   ) (vlax-get-acad-object) )
  (princ)
)

(defun C:InstalarFDRC( / ) (SetFolderFDRC))

(SetFolderFDRC)
(princ)
;;(InstalarFDRC "C:\\GAMLPCatastro2007" "catastro_fdrc" "CATASTROFDRC")

